searchNodes=[{"ref":"Rajska.html","title":"Rajska","type":"module","doc":"Rajska is an elixir authorization library for Absinthe. It provides the following middlewares: Rajska.QueryAuthorization Rajska.QueryScopeAuthorization Rajska.ObjectAuthorization Rajska.ObjectScopeAuthorization Rajska.FieldAuthorization Installation The package can be installed by adding rajska to your list of dependencies in mix.exs: def deps do [ {:rajska, &quot;~&gt; 1.0.2&quot;}, ] end Usage Create your Authorization module, which will implement the Rajska.Authorization behaviour and contain the logic to validate user permissions and will be called by Rajska middlewares. Rajska provides some helper functions by default, such as Rajska.Authorization.role_authorized?/2 and Rajska.Authorization.has_user_access?/3, but you can override them with your application needs. defmodule Authorization do use Rajska, valid_roles: [:user, :admin] end Available options and their default values: valid_roles: [:admin], super_role: :admin, default_rule: :default Add your Authorization module to your Absinthe.Schemacontext/1 callback and the desired middlewares to the middleware/3 callback: def context(ctx), do: Map.put(ctx, :authorization, Authorization) def middleware(middleware, field, %Absinthe.Type.Object{identifier: identifier}) when identifier in [:query, :mutation] do middleware |&gt; Rajska.add_query_authorization(field, Authorization) |&gt; Rajska.add_object_authorization() end def middleware(middleware, field, object) do Rajska.add_field_authorization(middleware, field, object) end Since Scope Authorization middleware must be used with Query Authorization, it is automatically called when adding the former."},{"ref":"Rajska.html#add_field_authorization/3","title":"Rajska.add_field_authorization/3","type":"function","doc":"See Rajska.Schema.add_field_authorization/3."},{"ref":"Rajska.html#add_object_authorization/1","title":"Rajska.add_object_authorization/1","type":"function","doc":"See Rajska.Schema.add_object_authorization/1."},{"ref":"Rajska.html#add_query_authorization/3","title":"Rajska.add_query_authorization/3","type":"function","doc":"See Rajska.Schema.add_query_authorization/3."},{"ref":"Rajska.Authorization.html","title":"Rajska.Authorization","type":"behaviour","doc":"Behaviour of an Authorization module."},{"ref":"Rajska.Authorization.html#c:context_role_authorized?/2","title":"Rajska.Authorization.context_role_authorized?/2","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:context_user_authorized?/3","title":"Rajska.Authorization.context_user_authorized?/3","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:get_current_user/1","title":"Rajska.Authorization.get_current_user/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:get_ip/1","title":"Rajska.Authorization.get_ip/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:get_user_role/1","title":"Rajska.Authorization.get_user_role/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:has_user_access?/3","title":"Rajska.Authorization.has_user_access?/3","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:not_scoped_roles/0","title":"Rajska.Authorization.not_scoped_roles/0","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:role_authorized?/2","title":"Rajska.Authorization.role_authorized?/2","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:unauthorized_message/1","title":"Rajska.Authorization.unauthorized_message/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#t:context/0","title":"Rajska.Authorization.context/0","type":"type","doc":""},{"ref":"Rajska.Authorization.html#t:current_user/0","title":"Rajska.Authorization.current_user/0","type":"type","doc":""},{"ref":"Rajska.Authorization.html#t:current_user_role/0","title":"Rajska.Authorization.current_user_role/0","type":"type","doc":""},{"ref":"Rajska.Authorization.html#t:role/0","title":"Rajska.Authorization.role/0","type":"type","doc":""},{"ref":"Rajska.Authorization.html#t:rule/0","title":"Rajska.Authorization.rule/0","type":"type","doc":""},{"ref":"Rajska.Authorization.html#t:scoped_struct/0","title":"Rajska.Authorization.scoped_struct/0","type":"type","doc":""},{"ref":"Rajska.FieldAuthorization.html","title":"Rajska.FieldAuthorization","type":"module","doc":"Absinthe middleware to ensure field permissions. Authorizes Absinthe&#39;s object field according to the result of the Rajska.Authorization.has_user_access?/3 function, which receives the user role, the source object that is resolving the field and the field rule. Usage Create your Authorization module and add it and FieldAuthorization to your Absinthe.Schema. object :user do # Turn on both Object and Field scoping, but if the ObjectScope Phase is not included, this is the same as using `scope_field?` meta :scope?, true field :name, :string field :is_email_public, :boolean field :phone, :string, meta: [private: true] field :email, :string, meta: [private: &amp; !&amp;1.is_email_public] # Can also use custom rules for each field field :always_private, :string, meta: [private: true, rule: :private] end object :field_scope_user do meta :scope_field?, true field :name, :string field :phone, :string, meta: [private: true] end As seen in the example above, a function can also be passed as value to the meta :private key, in order to check if a field is private dynamically, depending of the value of another field."},{"ref":"Rajska.FieldAuthorization.html#call/2","title":"Rajska.FieldAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.ObjectAuthorization.html","title":"Rajska.ObjectAuthorization","type":"module","doc":"Absinthe middleware to ensure object permissions. Authorizes all Absinthe&#39;s objects requested in a query by checking the permission defined in each object meta authorize. Usage Create your Authorization module and add it and QueryAuthorization to your Absinthe.Schema. Then set the permitted role to access an object: object :wallet_balance do meta :authorize, :admin field :total, :integer end object :company do meta :authorize, :user field :name, :string field :wallet_balance, :wallet_balance end object :user do meta :authorize, :all field :email, :string field :company, :company end With the permissions above, a query like the following would only be allowed by an admin user: { userQuery { name email company { name walletBalance { total } } } } Object Authorization middleware runs after Query Authorization middleware (if added) and before the query is resolved by recursively checking the requested objects permissions in the Rajska.Authorization.role_authorized?/2 function (which is also used by Query Authorization). It can be overridden by your own implementation."},{"ref":"Rajska.ObjectAuthorization.html#call/2","title":"Rajska.ObjectAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.ObjectScopeAuthorization.html","title":"Rajska.ObjectScopeAuthorization","type":"module","doc":"Absinthe Phase to perform object scoping. Authorizes all Absinthe&#39;s objects requested in a query by checking the underlying struct. Usage Create your Authorization module and add it and ObjectScopeAuthorization to your Absinthe Pipeline. Then set the scope of an object: object :user do # Turn on Object and Field scoping, but if the FieldAuthorization middleware is not included, this is the same as using `scope_object?` meta :scope?, true field :id, :integer field :email, :string field :name, :string field :company, :company end object :company do meta :scope_object?, true field :id, :integer field :user_id, :integer field :name, :string field :wallet, :wallet end object :wallet do meta :scope?, true meta :rule, :object_authorization field :total, :integer end To define custom rules for the scoping, use has_user_access?/3. For example: defmodule Authorization do use Rajska, valid_roles: [:user, :admin], super_role: :admin @impl true def has_user_access?(%{role: :admin}, %User{}, _rule), do: true def has_user_access?(%{id: user_id}, %User{id: id}, _rule) when user_id === id, do: true def has_user_access?(_current_user, %User{}, _rule), do: false def has_user_access?(%{id: user_id}, %Wallet{user_id: id}, :object_authorization), do: user_id == id def has_user_access?(%{id: user_id}, %Wallet{user_id: id}, :always_block), do: false end This way different rules can be set to the same struct. See Rajska.Authorization for rule default settings."},{"ref":"Rajska.ObjectScopeAuthorization.html#flag_invalid/1","title":"Rajska.ObjectScopeAuthorization.flag_invalid/1","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#flag_invalid/2","title":"Rajska.ObjectScopeAuthorization.flag_invalid/2","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#inherit_invalid/3","title":"Rajska.ObjectScopeAuthorization.inherit_invalid/3","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#put_flag/2","title":"Rajska.ObjectScopeAuthorization.put_flag/2","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#run/2","title":"Rajska.ObjectScopeAuthorization.run/2","type":"function","doc":"Callback implementation for Absinthe.Phase.run/2."},{"ref":"Rajska.QueryAuthorization.html","title":"Rajska.QueryAuthorization","type":"module","doc":"Absinthe middleware to ensure query permissions. Usage Create your Authorization module and add it and QueryAuthorization to your Absinthe.Schema. Then set the permitted role to access a query or mutation: mutation do field :create_user, :user do arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, permit: :all resolve &amp;AccountsResolver.create_user/2 end field :update_user, :user do arg :id, non_null(:integer) arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, [permit: :user, scope: User] # same as [permit: :user, scope: User, args: :id] resolve &amp;AccountsResolver.update_user/2 end field :delete_user, :user do arg :id, non_null(:integer) middleware Rajska.QueryAuthorization, permit: :admin resolve &amp;AccountsResolver.delete_user/2 end end Query authorization will call Rajska.Authorization.role_authorized?/2 to check if the userrole is authorized to perform the query."},{"ref":"Rajska.QueryAuthorization.html#call/2","title":"Rajska.QueryAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.QueryScopeAuthorization.html","title":"Rajska.QueryScopeAuthorization","type":"module","doc":"Absinthe middleware to perform query scoping. Usage Create your Authorization module and add it and QueryAuthorization to your Absinthe.Schema. Since Scope Authorization middleware must be used with Query Authorization, it is automatically called when adding the former. Then set the scoped module and argument field: mutation do field :create_user, :user do arg :params, non_null(:user_params) # all does not require scoping, since it means anyone can execute this query, even without being logged in. middleware Rajska.QueryAuthorization, permit: :all resolve &amp;AccountsResolver.create_user/2 end field :update_user, :user do arg :id, non_null(:integer) arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, [permit: :user, scope: User] # same as [permit: :user, scope: User, args: :id] resolve &amp;AccountsResolver.update_user/2 end field :delete_user, :user do arg :user_id, non_null(:integer) # Providing a map for args is useful to map query argument to struct field. middleware Rajska.QueryAuthorization, [permit: [:user, :manager], scope: User, args: %{id: :user_id}] resolve &amp;AccountsResolver.delete_user/2 end input_object :user_params do field :id, non_null(:integer) end field :accept_user, :user do arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, [ permit: :user, scope: User, args: %{id: [:params, :id]}, rule: :accept_user ] resolve &amp;AccountsResolver.invite_user/2 end end In the above example, :all and :admin permissions don&#39;t require the :scope keyword, as defined in the Rajska.Authorization.not_scoped_roles/0 function, but you can modify this behavior by overriding it. Options All the following options are sent to Rajska.Authorization.has_user_access?/3: :scope false: disables scoping User: a module that will be passed to Rajska.Authorization.has_user_access?/3. It must define a struct. :args %{user_id: [:params, :id]}: where user_id is the scoped field and id is an argument nested inside the params argument. :id: this is the same as %{id: :id}, where :id is both the query argument and the scoped field that will be passed to Rajska.Authorization.has_user_access?/3 [:code, :user_group_id]: this is the same as %{code: :code, user_group_id: :user_group_id}, where code and user_group_id are both query arguments and scoped fields. :optional (optional) - when set to true the arguments are optional, so if no argument is provided, the query will be authorized. Defaults to false. :rule (optional) - allows the same struct to have different rules. See Rajska.Authorization for rule default settings."},{"ref":"Rajska.QueryScopeAuthorization.html#call/2","title":"Rajska.QueryScopeAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.QueryScopeAuthorization.html#get_scoped_struct_field/4","title":"Rajska.QueryScopeAuthorization.get_scoped_struct_field/4","type":"function","doc":""},{"ref":"Rajska.QueryScopeAuthorization.html#scope_user!/2","title":"Rajska.QueryScopeAuthorization.scope_user!/2","type":"function","doc":""},{"ref":"Rajska.RateLimiter.html","title":"Rajska.RateLimiter","type":"module","doc":"Rate limiter absinthe middleware. Uses Hammer. Usage First configure Hammer, following its documentation. For example: config :hammer, backend: {Hammer.Backend.ETS, [expiry_ms: 60_000 * 60 * 4, cleanup_interval_ms: 60_000 * 10]} Add your middleware to the query that should be limited: field :default_config, :string do middleware Rajska.RateLimiter resolve fn _, _ -&gt; {:ok, &quot;ok&quot;} end end You can also configure it and use multiple rules for limiting in one query: field :login_user, :session do arg :email, non_null(:string) arg :password, non_null(:string) middleware Rajska.RateLimiter, limit: 10 # Using the default identifier (user IP) middleware Rajska.RateLimiter, keys: :email, limit: 5 # Using the value provided in the email arg resolve &amp;AccountsResolver.login_user/2 end The allowed configuration are: scale_ms: The timespan for the maximum number of actions. Defaults to 60_000. limit: The maximum number of actions in the specified timespan. Defaults to 10. id: An atom or string to be used as the bucket identifier. Note that this will always be the same, so by using this the limit will be global instead of by user. keys: An atom or a list of atoms to get a query argument as identifier. Use a list when the argument is nested. error_msg: The error message to be displayed when rate limit exceeds. Defaults to &quot;Too many requests&quot;. Note that when neither id or keys is provided, the default is to use the user&#39;s IP. For that, the default behaviour is to use Rajska.Authorization.get_ip/1 to fetch the IP from the absinthe context. That means you need to manually insert the user&#39;s IP in the absinthe context before using it as an identifier. See the absinthe docs for more information."},{"ref":"Rajska.RateLimiter.html#call/2","title":"Rajska.RateLimiter.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.Schema.html","title":"Rajska.Schema","type":"module","doc":"Concatenates Rajska middlewares with Absinthe middlewares and validates Query Authorization configuration."},{"ref":"Rajska.Schema.html#add_field_authorization/3","title":"Rajska.Schema.add_field_authorization/3","type":"function","doc":""},{"ref":"Rajska.Schema.html#add_object_authorization/1","title":"Rajska.Schema.add_object_authorization/1","type":"function","doc":""},{"ref":"Rajska.Schema.html#add_query_authorization/3","title":"Rajska.Schema.add_query_authorization/3","type":"function","doc":""},{"ref":"Rajska.Schema.html#validate_query_auth_config!/3","title":"Rajska.Schema.validate_query_auth_config!/3","type":"function","doc":""}]